PImage city;
PImage tower;
PImage truck_one; 
PImage truck_two;

int maxtowers=10;
int[] loc = new int[maxtowers]; // location, i.e. x value
int[] lvl = new int[maxtowers]; // level, i.e. height
int towers=0;

void setup() {
  size(750,200);
  city      = loadImage("city.jpg"); 
  tower     = loadImage("tower.jpg");
  truck_one = loadImage("truck_one.jpg");
  truck_two = loadImage("truck_two.jpg");
}

int x=0;
boolean rightward = true;
boolean done = false;

void draw() {
  // display background
  tint(255,128);
  image(city,0,0);
  
  // move truck autonomously
  if (random(0,5)>4) {
     if (rightward)
        x=x+2;
        else x=x-2;
  }
  if (x<0) x=0;
  if (x>750) x=750;
  
  // display truck
  tint(255,128);
  if (!done && rightward)  image(truck_two,x,200-25,50,25);
  if (!done && !rightward) image(truck_one,x,200-25,50,25);
  
  // display towers for indexes 0..towers-1
  tint(255,128);
  for (int i=0; i<towers; i++)
       if (loc[i]>=0)
           image(tower,loc[i],200-lvl[i],50,lvl[i]);
  if (x>=750)
      done=done||true;
  if (done) {
      int i=tallest();  
      tint(255,255); 
      image(tower,loc[i],200-lvl[i],50,lvl[i]);
      int a=average();
      stroke(255);
      line(0, 200-a, 750, 200-a);
  }
}

int tallest() {
    int m=-1; // max level found so far
    int i=-1; // index where it's found
    for (int j=0; j<towers; j++)
        if (lvl[j] > m) {
           m = lvl[j];
           i = j;
        }
    return i;
}

int rightmost() {
    int m=-1; // max x location found so far
    int i=-1; // index where this x is found
    for (int j=0; j<towers; j++)
        if (loc[j] > m) {
           m = loc[j];
           i = j;
        }
    return i;
}

int average() {
    int s=0; // sum calculated so far
    for (int j=0; j<towers; j++)
        s = s+lvl[j];
    if (towers>0)
        return s / towers;
        else return 1;
}

void keyPressed() {
  if(keyCode == UP)    {  } 
  if(keyCode == DOWN)  {  } 
  if(keyCode == LEFT)  { rightward=false; x=x-2; } 
  if(keyCode == RIGHT) { rightward=true;  x=x+2; } 
  if(key == ' ') { // add tower
      if (towers<maxtowers){
         loc[towers]=x; 
         lvl[towers]=floor(random(0,200)); 
         towers++;
      } 
  } 
  if(keyCode == ENTER) { done=done||true;  }
}
